package com.qmth.distributed.print.business.bean.dto.report;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;

/**
 * @Description: 平时成绩dto
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2024/2/26
 */
@JsonInclude(JsonInclude.Include.NON_NULL)
public class UsualScoreWordDto implements Serializable {

    @ApiModelProperty(value = "平时成绩目标总分")
    private BigDecimal usualScoreTargetSumScore = new BigDecimal(0);

    @ApiModelProperty(value = "平时成绩目标整体权重")
    private BigDecimal usualScoreTargetSumWeight = new BigDecimal(0);

    @ApiModelProperty(value = "平时成绩详情")
    private List<ReportEvaluationDto> usualScoreDetailList;

    public UsualScoreWordDto() {

    }

    public UsualScoreWordDto(BigDecimal usualScoreTargetSumWeight) {
        this.usualScoreTargetSumWeight = usualScoreTargetSumWeight;
    }

    public List<ReportEvaluationDto> getUsualScoreDetailList() {
        return usualScoreDetailList;
    }

    public void setUsualScoreDetailList(List<ReportEvaluationDto> usualScoreDetailList) {
        this.usualScoreDetailList = usualScoreDetailList;
    }

    public BigDecimal getUsualScoreTargetSumScore() {
        return usualScoreTargetSumScore;
    }

    public void setUsualScoreTargetSumScore(BigDecimal usualScoreTargetSumScore) {
        this.usualScoreTargetSumScore = usualScoreTargetSumScore;
    }

    public BigDecimal getUsualScoreTargetSumWeight() {
        return usualScoreTargetSumWeight;
    }

    public void setUsualScoreTargetSumWeight(BigDecimal usualScoreTargetSumWeight) {
        this.usualScoreTargetSumWeight = usualScoreTargetSumWeight;
    }
}
