package com.qmth.distributed.print.business.entity;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.teachcloud.common.base.BaseEntity;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;

/**
 * <p>
 * 考生
 * </p>
 *
 * @author xf
 * @since 2021-03-23
 */
@TableName("exam_student")
public class ExamStudent extends BaseEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "学校id")
    @JsonSerialize(using = ToStringSerializer.class)
    @TableField("school_id")
    private Long schoolId;

    @ApiModelProperty(value = "机构id")
    @JsonSerialize(using = ToStringSerializer.class)
    @TableField(value = "org_id", updateStrategy = FieldStrategy.IGNORED)
    private Long orgId;

    @TableField("exam_detail_course_id")
    private Long examDetailCourseId;

    @TableField("student_name")
    private String studentName;

    @TableField("student_code")
    private String studentCode;

    @TableField("exam_id")
    private Long examId;

    @TableField("paper_number")
    private String paperNumber;

    @TableField("course_paper_id")
    private String coursePaperId;

    @TableField("ticket_number")
    private String ticketNumber;

    @TableField("site_number")
    private String siteNumber;

    @TableField("print_paper")
    private Integer printPaper;

    @TableField("print_card")
    private Integer printCard;

    @TableField("required_fields")
    private String requiredFields;

    @TableField("extend_fields")
    private String extendFields;

    @TableField("paper_type")
    private String paperType;

    @TableField("college_name")
    private String collegeName;

    @TableField("major_name")
    private String majorName;

    @TableField("clazz_id")
    private String clazzId;

    @TableField("clazz_name")
    private String clazzName;

    @ApiModelProperty(value = "教学班id")
    @TableField("clazz_id")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long teachClazzId;

    @ApiModelProperty(value = "教学班名称")
    @TableField("teach_clazz_name")
    private String teachClazzName;

    @TableField("campus_name")
    private String campusName;

    @TableField("teacher_id")
    private Long teacherId;

    @JsonSerialize(using = ToStringSerializer.class)
    @ApiModelProperty(value = "附件id")
    @TableField(value = "attachment_id")
    private Long attachmentId;

    @TableField(value = "can_delete")
    private Boolean canDelete;

    public Long getSchoolId() {
        return schoolId;
    }

    public void setSchoolId(Long schoolId) {
        this.schoolId = schoolId;
    }

    public Long getOrgId() {
        return orgId;
    }

    public void setOrgId(Long orgId) {
        this.orgId = orgId;
    }

    public Long getExamDetailCourseId() {
        return examDetailCourseId;
    }

    public void setExamDetailCourseId(Long examDetailCourseId) {
        this.examDetailCourseId = examDetailCourseId;
    }

    public String getStudentName() {
        return studentName;
    }

    public void setStudentName(String studentName) {
        this.studentName = studentName;
    }

    public String getStudentCode() {
        return studentCode;
    }

    public void setStudentCode(String studentCode) {
        this.studentCode = studentCode;
    }

    public Long getExamId() {
        return examId;
    }

    public void setExamId(Long examId) {
        this.examId = examId;
    }

    public String getPaperNumber() {
        return paperNumber;
    }

    public void setPaperNumber(String paperNumber) {
        this.paperNumber = paperNumber;
    }

    public String getCoursePaperId() {
        return coursePaperId;
    }

    public void setCoursePaperId(String coursePaperId) {
        this.coursePaperId = coursePaperId;
    }

    public String getTicketNumber() {
        return ticketNumber;
    }

    public void setTicketNumber(String ticketNumber) {
        this.ticketNumber = ticketNumber;
    }

    public String getSiteNumber() {
        return siteNumber;
    }

    public void setSiteNumber(String siteNumber) {
        this.siteNumber = siteNumber;
    }

    public Integer getPrintPaper() {
        return printPaper;
    }

    public void setPrintPaper(Integer printPaper) {
        this.printPaper = printPaper;
    }

    public Integer getPrintCard() {
        return printCard;
    }

    public void setPrintCard(Integer printCard) {
        this.printCard = printCard;
    }

    public String getRequiredFields() {
        return requiredFields;
    }

    public void setRequiredFields(String requiredFields) {
        this.requiredFields = requiredFields;
    }

    public String getExtendFields() {
        return extendFields;
    }

    public void setExtendFields(String extendFields) {
        this.extendFields = extendFields;
    }

    public String getPaperType() {
        return paperType;
    }

    public void setPaperType(String paperType) {
        this.paperType = paperType;
    }

    public String getCollegeName() {
        return collegeName;
    }

    public void setCollegeName(String collegeName) {
        this.collegeName = collegeName;
    }

    public String getMajorName() {
        return majorName;
    }

    public void setMajorName(String majorName) {
        this.majorName = majorName;
    }

    public String getClazzId() {
        return clazzId;
    }

    public void setClazzId(String clazzId) {
        this.clazzId = clazzId;
    }

    public String getClazzName() {
        return clazzName;
    }

    public void setClazzName(String clazzName) {
        this.clazzName = clazzName;
    }

    public Long getTeachClazzId() {
        return teachClazzId;
    }

    public void setTeachClazzId(Long teachClazzId) {
        this.teachClazzId = teachClazzId;
    }

    public String getTeachClazzName() {
        return teachClazzName;
    }

    public void setTeachClazzName(String teachClazzName) {
        this.teachClazzName = teachClazzName;
    }

    public String getCampusName() {
        return campusName;
    }

    public void setCampusName(String campusName) {
        this.campusName = campusName;
    }

    public Long getTeacherId() {
        return teacherId;
    }

    public void setTeacherId(Long teacherId) {
        this.teacherId = teacherId;
    }

    public Long getAttachmentId() {
        return attachmentId;
    }

    public void setAttachmentId(Long attachmentId) {
        this.attachmentId = attachmentId;
    }

    public Boolean getCanDelete() {
        return canDelete;
    }

    public void setCanDelete(Boolean canDelete) {
        this.canDelete = canDelete;
    }
}
