package com.qmth.distributed.print.business.mapper;

import com.qmth.distributed.print.business.bean.result.CourseEvaluationResult;
import com.qmth.distributed.print.business.entity.CourseEvaluation;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * 课程评价方式 Mapper 接口
 * </p>
 *
 * @author CaoZixuan
 * @since 2024-02-22
 */
public interface CourseEvaluationMapper extends BaseMapper<CourseEvaluation> {

    /**
     * 查询课程评价方式集合
     *
     * @param teachCourseId 教学课程id
     * @return 课程评价方式列表
     */
    List<CourseEvaluationResult> findCourseEvaluationList(@Param("teachCourseId") Long teachCourseId);
}
