package com.qmth.distributed.print.business.service;

import com.qmth.distributed.print.business.bean.params.CourseEvaluationParam;
import com.qmth.distributed.print.business.bean.result.CourseEvaluationResult;
import com.qmth.distributed.print.business.entity.CourseEvaluation;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.teachcloud.common.entity.SysUser;

import java.util.List;

/**
 * <p>
 * 课程评价方式 服务类
 * </p>
 *
 * @author CaoZixuan
 * @since 2024-02-22
 */
public interface CourseEvaluationService extends IService<CourseEvaluation> {

    /**
     * 查询课程评价方式集合
     *
     * @param teachCourseId 教学课程id
     * @return 课程评价方式结果
     */
    List<CourseEvaluationResult> findCourseEvaluationList(Long teachCourseId);

    /**
     * 保存课程评价方式
     *
     * @param courseEvaluationParam 课程评价方式参数
     */
    void saveCourseEvaluation(CourseEvaluationParam courseEvaluationParam);

    /**
     * 删除课程评价方式
     *
     * @param id 课程评价方式id
     */
    void deleteCourseEvaluation(Long id);

    /**
     * 创建默认的评价方式
     *
     * @param teachCourseId 教学课程id
     */
    void createDefaultCourseEvaluation(Long teachCourseId);
}