package com.qmth.distributed.print.business.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.distributed.print.business.bean.dto.TaskPrintHouseDto;
import com.qmth.distributed.print.business.entity.ExamTaskPrint;
import com.qmth.teachcloud.common.bean.dto.TaskPrintClassDto;

import java.util.List;

/**
 * <p>
 * 以试卷作为起点生成考务数据 服务类
 * </p>
 *
 * @author xf
 * @since 2021-08-02
 */
public interface ExamTaskPrintService extends IService<ExamTaskPrint> {
    List<TaskPrintHouseDto> listHouse();

    /**
     * 查找考场
     * <p>
     * 入库申请里——新建任务，需要命题老师提交试卷+考务数据的模式，课程选择范围依然是从字典里取数据，列表显示当前用户所在机构下的全部课程，
     * 考务数据选择班级，优先查看基础信息里是否有当前用户自己在基础管理里创建的数据，如果没有选择字典
     * 如果基础管理创建的班级数据，无命题老师想选择的，选择班级下拉列表应该有一个选项，创建班级
     * </p>
     *
     * @param courseCode 课程编号
     * @return 结果
     */
    List<TaskPrintClassDto> listExamTaskClass(String courseCode);
}
