package com.qmth.distributed.print.api.admin;

import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.distributed.print.business.bean.result.EditResult;
import com.qmth.distributed.print.business.service.ClientUpgradeService;
import com.qmth.distributed.print.business.service.PrintCommonService;
import com.qmth.distributed.print.business.service.TeachCourseService;
import com.qmth.teachcloud.common.annotation.OperationLogDetail;
import com.qmth.teachcloud.common.bean.params.BasicCourseParams;
import com.qmth.teachcloud.common.contant.SystemConstant;
import com.qmth.teachcloud.common.entity.BasicCourse;
import com.qmth.teachcloud.common.entity.SysUser;
import com.qmth.teachcloud.common.enums.ExceptionResultEnum;
import com.qmth.teachcloud.common.enums.clientpackage.ClientPackageEnum;
import com.qmth.teachcloud.common.enums.log.CustomizedOperationTypeEnum;
import com.qmth.teachcloud.common.enums.log.LevelEnum;
import com.qmth.teachcloud.common.enums.log.OperationTypeEnum;
import com.qmth.teachcloud.common.service.BasicCourseService;
import com.qmth.teachcloud.common.util.Result;
import com.qmth.teachcloud.common.util.ResultUtil;
import com.qmth.teachcloud.common.util.ServletUtil;
import io.swagger.annotations.*;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;
import org.springframework.validation.BindingResult;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;
import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 * 客户端升级 前端控制器
 */
@Api(tags = "超管-客户端升级Controller")
@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + SystemConstant.PREFIX_URL_SYS + "/client/package")
@Validated
public class ClientUpgradeController {

    @Resource
    private ClientUpgradeService clientUpgradeService;

    @ApiOperation(value = "上传安装包/升级包")
    @RequestMapping(value = "/upload", method = RequestMethod.POST)
    public Result query(@ApiParam(value = "上传文件", required = true) @RequestParam(value = "file") MultipartFile file,
                        @ApiParam(value = "文件MD5", required = true) @RequestParam(value = "md5") String md5,
                        @ApiParam(value = "上传文件", required = true) @RequestParam(value = "type") ClientPackageEnum type) {
        clientUpgradeService.upload(file, md5, type);
        return ResultUtil.ok(true);
    }

    @ApiOperation(value = "升级信息接口")
    @RequestMapping(value = "/external", method = RequestMethod.POST)
    public Result remove(@RequestBody BasicCourse course) {
        return ResultUtil.ok();
    }

}

